{ (C) Alex V. Krasnov, Troitsk, 1996, verion 1.2b                }

{ ଠ  ⠪     Turbo Pascal'e                 }
{   ६ ᯮ x1,x2,...,x[MaxDifferents]  }
{  㦭  ⮣ ⮡  ࠧ             }
{ 㫠  ⨬ (5+10+12     }
{  ⢥), ⥯  ⮫쪮  ⥫   }
{ 祭 ( 訡 ᫥)                             }
{   ⥫   ^, *  /  ਮ  }
{  饬  ࠢ :)                                 }

unit formula;
interface

const
     { ᨬ쭮 ⢮ ६ }
     maxdifferents              = 15;
type
    Ppoint      = ^Tpoint;
    nextpart    = record
                { ࠡ⪠ 㭪樨: , , ᨭ, ᨭ,
                                     ᯮ, ⠭ }
                functions       : (nothing,logarifm,cosinus,sinus,
                                   exponent,arctangens);
                { ᫥騩 㬥: ࠧ, 祭,  ६ }
                case style      : (point,value,different) of
                     point      : (nextpoint:Ppoint);
                     value      : (value:real);
                     different  : (number:byte);
    end;

    Tpoint      = record
                { : , , ⥯, 㬭,  }
                operation       : (minus,plus,extent,
                                   division,multiplication);
                { ࠢ    }
                left,right      : nextpart;
    end;

    Tformula    = object
                { ६ }
                x               : array[1..maxdifferents] of real;
                { 設 ॢ }
                tree            : Ppoint;
    public
                { true ᫨ 訡 ᫥ }
                errorcount      : boolean;

                { true ᫨ 訡 ஥ ॢ (ࠧ ࠦ) }
                errorsyntax     : boolean;

                { ᮧ ॢ line }
                procedure init(line:string);

                {   }
                function result:real;

                { 㤠  }
                procedure done;

                { ⠭  ६ c ஬ number 祭 value }
                procedure setdifferent(number:byte;value:real);

                { 頥 true ᫨ ६   ॢ }
                function existdifferent(number:byte):boolean;
    private
                { 㤠 譨 ᪮ ࠢ  ᫥ }
                procedure delbrackets(var line:string);

                {  ॢ }
                function resultpart(part:nextpart):real;
                function count(start:Ppoint):real;

                { ନ஢ ॢ }
                procedure convert(line:string;var start:Ppoint);
                procedure makepart(line:string;var part:nextpart);

                { 頥 true ᫨ ६   ॢ }
                function exist(start:nextpart;number:byte):boolean;

                { 㤠  }
                procedure deltree(var start:Ppoint);
    end;

implementation

procedure Tformula.init(line:string);
var
   index                : byte;
begin
     tree:=nil;
     errorsyntax:=false;
     while pos(' ',line)<>0 do delete(line,pos(' ',line),1);
     for index:=1 to length(line) do line[index]:=upcase(line[index]);
     convert(line,tree);
end;

function Tformula.result:real;
begin
     errorcount:=false;
     if not errorsyntax then result:=count(tree);
end;

procedure Tformula.setdifferent(number:byte;value:real);
begin
     x[number]:=value;
end;

procedure Tformula.done;
begin
     deltree(tree);
end;

function Tformula.resultpart(part:nextpart):real;
var
   tmp                  : real;
begin
     case part.style of
          value         : tmp:=part.value;
          different     : tmp:=x[part.number];
          point         : tmp:=count(part.nextpoint);
     end;
     case part.functions of
          nothing       : ;
          logarifm      : if tmp>0 then tmp:=ln(tmp) else errorcount:=true;
          exponent      : tmp:=exp(tmp);
          cosinus       : tmp:=cos(tmp);
          sinus         : tmp:=sin(tmp);
          arctangens    : tmp:=arctan(tmp);
     end;
     resultpart:=tmp;
end;

function Tformula.count(start:Ppoint):real;
var
   left,right   : real;
   tmp          : real;
begin
     left:=resultpart(start^.left);
     right:=resultpart(start^.right);
     case start^.operation of
          minus         : tmp:=left-right;
          plus          : tmp:=left+right;
          division      : if right=0 then errorcount:=true
                                     else tmp:=left/right;
          multiplication: tmp:=left*right;
          extent        : begin
                               if left=0 then tmp:=0;
                               if left>0 then tmp:=exp(right*ln(left));
                               if left<0 then errorcount:=true;
                          end;
     end;
     count:=tmp;
end;

procedure Tformula.delbrackets(var line:string);
var
   index,
   level        : integer;
   haveto       : boolean;
begin
     if errorsyntax then exit;
     haveto:=true;
     if line[1]<>'(' then haveto:=false;
     level:=0;
     for index:=1 to length(line) do
         begin
              case line[index] of
                   '(':inc(level);
                   ')':dec(level);
              end;
              if (level=0) and (index<>length(line)) then haveto:=false;
              if (level<0) then errorsyntax:=true;
         end;
     if level<>0 then errorsyntax:=true;
     if haveto then
        begin
             delete(line,1,1);
             delete(line,length(line),1);
             delbrackets(line);
        end;
end;

procedure Tformula.makepart(line:string;var part:nextpart);
var
   index,
   level                : integer;
   position             : byte;
   figure               : real;
   number,
   error                : integer;
   operand              : string;
   haveto               : boolean;
begin
     if line='' then errorsyntax:=true;
     if errorsyntax then exit;
     delbrackets(line);
     position:=pos('*',line)+pos('/',line)+
               pos('-',line)+pos('+',line)+pos('^',line);
     part.functions:=nothing;
     operand:=copy(line,1,pos('(',line)-1);

     level:=0;
     if (pos('(',line)>1) then haveto:=true else haveto:=false;
     for index:=pos('(',line) to length(line) do
         begin
              case line[index] of
                   '(':inc(level);
                   ')':dec(level);
              end;
              if (level=0) and (index<>length(line)) then
                 haveto:=false;
         end;
     if haveto then
        begin
             if operand='LN' then part.functions:=logarifm;
             if operand='COS' then part.functions:=cosinus;
             if operand='SIN' then part.functions:=sinus;
             if operand='EXP' then part.functions:=exponent;
             if operand='ARCTAN' then part.functions:=arctangens;
             if part.functions<>nothing then
                begin
                     delete(line,1,pos('(',line)-1);
                     part.style:=point;
                     convert(line,part.nextpoint);
                     exit;
                end;
        end;

     if (position=0) then
        begin
             if line[1]='X' then
                begin
                     val(copy(line,2,length(line)-1),number,error);
                     if error<>0 then errorsyntax:=true
                        else if (number<1) or (number>maxdifferents)
                             then errorsyntax:=true;
                     part.style:=different;
                     part.number:=number;
                end
             else
                 begin
                      val(line,figure,error);
                      if error<>0 then errorsyntax:=true;
                      part.style:=value;
                      part.value:=figure;
                 end;
        end
     else begin
               part.style:=point;
               convert(line,part.nextpoint);
          end;
end;

procedure Tformula.convert(line:string;var start:Ppoint);
var
   index        : integer;
   position,
   level        : integer;
   left,right   : string;
begin
     delbrackets(line);
     if errorsyntax then exit;
     new(start);
     start^.left.style:=point;
     start^.left.nextpoint:=nil;
     start^.right.style:=point;
     start^.right.nextpoint:=nil;

     level:=0;
     position:=0;
     for index:=1 to length(line) do
         case line[index] of
              '(':inc(level);
              ')':dec(level);
              '+','-':if (level=0) then position:=index;
              '*','/','^':if (level=0) and (line[position]<>'+') and
                             (line[position]<>'-') then position:=index;
         end;

     case line[position] of
          '+':start^.operation:=plus;
          '-':start^.operation:=minus;
          '*':start^.operation:=multiplication;
          '/':start^.operation:=division;
          '^':start^.operation:=extent;
     end;

     left:='';
     if position=0 then
        begin
             right:=line;
             start^.operation:=plus;
        end
     else
         begin
              left:=copy(line,1,position-1);
              right:=copy(line,position+1,length(line));
         end;
     if (left='') and ((start^.operation=plus) or
        (start^.operation=minus)) then left:='0';

     makepart(left,start^.left);
     makepart(right,start^.right);
end;

procedure Tformula.deltree(var start:Ppoint);
begin
     if start=nil then exit;
     if start^.left.style=point then
        deltree(start^.left.nextpoint);
     if start^.right.style=point then
        deltree(start^.right.nextpoint);
     dispose(start);
     start:=nil;
end;

function Tformula.exist(start:nextpart;number:byte):boolean;
begin
     if (start.style=different) and (start.number=number)
        then exist:=true
        else exist:=false;
     if start.style=point then exist:=exist(start.nextpoint^.left,number) or
                                      exist(start.nextpoint^.right,number);
end;

function Tformula.existdifferent(number:byte):boolean;
begin
     existdifferent:=exist(tree^.left,number) or
                     exist(tree^.right,number);
end;

end.
